// digital_bell.ino
// ESP32

#define audioPin 25       // DAC audio output
#define steps 255

byte SineValues[steps];       
byte amplitude = 127;
byte offset = 128;
float ConversionFactor = (2*PI) / steps;        
float RadAngle; 

void setup() 
{  pinMode(audioPin, OUTPUT);
   
   // pre-calculation of sine values
   for(int alpha = 0; alpha < steps; alpha ++) 
   {  RadAngle = alpha * ConversionFactor;               
      SineValues[alpha]=(amplitude * sin(RadAngle)) + offset;
  }
}

void loop() 
{  for (int ampl = 25; ampl >=0 ; ampl--)         // envelope
   { for (unsigned int d = 0; d < 20; d++)        // cycles per step
     {  for (unsigned int j = 0; j < 255; j++)    // sine output
        {  dacWrite(audioPin, SineValues[j]/25.0*ampl); delayMicroseconds(3);
        }
     }
   }   
   delay(100); 
}
